<script lang="ts">
import { Component, Prop } from 'vue-property-decorator';
import type { Rect, Pixel, Point } from '@/data';
import type { ScrollTo } from '@/logic/ScrollActions';
import type { CanvasMouseEvent } from '../../canvas/canvas-events';
import LabelBehavior from '../LabelBehavior.vue';

interface State {
  offset: Pixel;
}

@Component
export default class BMinimapClickScroll extends LabelBehavior {
  onMouseDown(e: CanvasMouseEvent, smooth: boolean) {
    // If the click is outside the viewrect (which acts like the scrollbar elevator)
    if (e.x < this.viewRect.x || e.x > this.viewRect.x + this.viewRect.width) {
      const target = (e.x - this.viewRect.width / 2) as Pixel;
      // Just scroll to the position
      this.scrollTo({
        x: target,
        y: 0,
      } as Point, smooth);
    } else {
      // Otherwise, start a drag
      this.state = { offset: (this.viewRect.x - e.x) as Pixel };
    }
  }

  mounted() {
    this.register('all-mousedown', (e) => this.onMouseDown(e, true));
    // Make ctrl scroll click instant
    this.register('all-ctrl-mousedown', (e) => this.onMouseDown(e, false));

    this.register('document-mousemove', (e) => {
      if (this.state) {
        this.scrollTo({
          x: (e.x + this.state.offset),
          y: 0,
        } as Point, false);
      }
    });
    this.register('document-mouseup', () => {
      this.state = null;
    });
  }

  state: State | null = null;

  @Prop({ required: true })
  scrollTo!: ScrollTo;

  @Prop({ required: true })
  viewRect!: Rect;
}
</script>
<style scoped lang="scss">
.minimap-cursor {
  pointer-events: none;
  background-color: #000000;
  opacity: 0.2;
}
</style>
